@ECHO off
rem ******************************************************************************************************************************
rem * Licensed Materials - Property of IBM                                                                                       *
rem * (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
rem *                                                                                                                            *
rem *US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
rem ******************************************************************************************************************************


IF NOT DEFINED LOCALE (SET LOCALE= )
SET LOCEN=0409
SET LOCIT=0410 
SET LOCJP=0411 
SET LOCKO=0412 
SET LOCPO=0415 
SET LOCCHS=0804
SET LOCCHT=0404


IF NOT DEFINED CURINST (SET CURINST= )
IF NOT DEFINED DBNAME (SET DBNAME= )
IF NOT DEFINED DBUSER (SET DBUSER= )
IF NOT DEFINED DBPASSWD (SET DBPASSWD= )
IF NOT DEFINED NF_SCHEMA (SET NF_SCHEMA= )
IF NOT DEFINED STAR_SCHEMA (SET STAR_SCHEMA= )
IF NOT DEFINED REP_USER (SET REP_USER= )
IF NOT DEFINED DATA_HOME (SET DATA_HOME= )
IF NOT DEFINED START_YEAR (SET START_YEAR= )
IF NOT DEFINED END_YEAR (SET END_YEAR= )

IF NOT DEFINED JAVA_HOME (SET JAVA_HOME= )



SET EXITCODE=0
SET MESSAGE= xxx


IF NOT EXIST set_env.bat (
                           SET EXITCODE=4597 
                           GOTO done
                                    ) ELSE (                
                       call set_env.bat
                                  )



IF "%JAVA_HOME%" EQU " " (
SET EXITCODE= 4596 
GOTO done)  


SET CURDIR=%CD%

CD /d "%JAVA_HOME%\bin"
IF "%ERRORLEVEL%" EQU "1" (
SET EXITCODE=4596
GOTO done)

IF NOT EXIST java.exe (
SET EXITCODE= 4598
GOTO done   ) 

CD /d %CURDIR%

set path=%JAVA_HOME%\bin;%path%

REG QUERY "HKCU\Control Panel\International" /v Locale>locale.txt

java com.ibm.rational.vega.dw.SearchAndReplace %LOCIT% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCIT%
SET SQLVARF=ascii\vars_it.sql
call lang\it\messages.bat) 
java com.ibm.rational.vega.dw.SearchAndReplace %LOCJP% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCJP%
SET SQLVARF=ascii\vars_jp.sql
call lang\jp\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCKO% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCKO%
SET SQLVARF=ascii\vars_kr.sql
call lang\kr\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCPO% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCPO%
SET SQLVARF=ascii\vars_pl.sql
call lang\pl\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCCHS% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCCHS%
SET SQLVARF=ascii\vars_zh_CN.sql
call lang\zh_CN\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCCHT% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCCHT%
SET SQLVARF=ascii\vars_zh_TW.sql
call lang\zh_TW\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCEN% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCEN%
SET SQLVARF=ascii\vars_en.sql
call lang\en\messages.bat
)

IF "%LOCALE%" EQU " " (
SET LOCALE=%LOCEN%
SET SQLVARF=ascii\vars_en.sql
call lang\en\messages.bat)


SET EXITCODE=0
SET MESSAGE=No errors

SET /A SILENT=0
IF "%1" EQU "-silent" (
SET /A SILENT=1) 

SET DB2_CMD=
IF "%1" EQU "-debug" (SET DB2_CMD= db2 -tvsf ) ELSE (SET DB2_CMD= db2 -tsf)
IF "%2" NEQ "" (IF "%2" EQU "-debug" (SET DB2_CMD= db2 -tvf ) ELSE (SET DB2_CMD= db2 -tf))

ECHO %CRREWECH033%

IF %SILENT% EQU 0 (
SET /P CURINST=%CRREWPRMPT001% 
)
IF "%CURINST%" EQU " " (
SET EXITCODE=%CRREW4501E%
SET MESSAGE=%CRREWMSGE001%
GOTO done)  

IF %SILENT% EQU 0 (
SET /P DBNAME=%CRREWPRMPT028%
)
IF "%DBNAME%" EQU " " (
SET EXITCODE=%CRREW4502E%
SET MESSAGE=%CRREWMSGE002%
GOTO done) 

IF %SILENT% EQU 0 (
SET /P DBUSER=%CRREWPRMPT003%
)
IF "%DBUSER%" EQU " " (
SET EXITCODE=%CRREW4503E%
SET MESSAGE=%CRREWMSGE003%
GOTO done)

IF %SILENT% EQU 0 (
SET /P DBPASSWD=%CRREWPRMPT004%
)

IF "%DBPASSWD%" EQU " " (
SET EXITCODE=%CRREW4504E%
SET MESSAGE=%CRREWMSGE004%
GOTO done)

IF %SILENT% EQU 0 (
SET /P NF_SCHEMA=%CRREWPRMPT029%
)
IF "%NF_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4505E%
SET MESSAGE=%CRREWMSGE005%
GOTO done)

IF %SILENT% EQU 0 (
SET /P STAR_SCHEMA=%CRREWPRMPT030%
)
IF "%STAR_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4506E%
SET MESSAGE=%CRREWMSGE006%
GOTO done)

IF %SILENT% EQU 0 (
SET /P REP_USER=%CRREWPRMPT031%
)
IF "%REP_USER%" EQU " " (
SET EXITCODE=%CRREW4507E%
SET MESSAGE=%CRREWMSGE007%
GOTO done)

IF %SILENT% EQU 0 (
SET /P VIEW_REDEF=%CRREWPRMPT032%
)
IF "%VIEW_REDEF%" EQU " " (
SET VIEW_REDEF=0)

IF "%VIEW_REDEF%" NEQ "1" (
SET VIEW_REDEF=0)

SET CONNSTR= db2 CONNECT TO %DBNAME% USER %DBUSER% USING "%DBPASSWD%"

SET DB2INSTANCE=%CURINST%

IF NOT EXIST work_spc\nul (MKDIR work_spc) ELSE (
RMDIR /S /Q work_spc
MKDIR work_spc
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)
IF NOT EXIST logs\nul (MKDIR logs) ELSE (
RMDIR /S /Q logs
MKDIR logs
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

XCOPY /Y /I /E /Q ddl work_spc\ddl
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)

XCOPY /Y /I /E /Q scripts work_spc\scripts
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)


%CONNSTR%

db2 "INSERT INTO CONFIG.SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE)SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM CONFIG.SYSCONFIG_INFO WHERE INFO_ID=6)"

db2 "INSERT INTO CONFIG.SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'1.0.0.2' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM CONFIG.SYSCONFIG_INFO WHERE INFO_ID=7)"

db2 "UPDATE CONFIG.SYSCONFIG_INFO SET CHAR_VALUE='1.0.0.2' WHERE INFO_ID=7"

FOR /F "usebackq delims==" %%g IN (`%CONNSTR% ^& db2 -x + -o - "SELECT COUNT(*) FROM %STAR_SCHEMA%.CAL_MESSAGES WHERE CAL_MESSAGE_CODE IN ('CRREW4598E','CRREW4599E','CRREW4600E','CRREW4601E','CRREW4602E')"`) do (set EXISTS=%%g)   

SET EXISTS=%EXISTS: =%
IF "%EXISTS: =%" EQU "0" (
java com.ibm.rational.vega.dw.SearchAndReplace CRREW4598E work_spc\scripts\%SQLVARF%>>work_spc\scripts\messages.sql
java com.ibm.rational.vega.dw.SearchAndReplace CRREW4599E work_spc\scripts\%SQLVARF%>>work_spc\scripts\messages.sql
java com.ibm.rational.vega.dw.SearchAndReplace CRREW4600E work_spc\scripts\%SQLVARF%>>work_spc\scripts\messages.sql
java com.ibm.rational.vega.dw.SearchAndReplace CRREW4601E work_spc\scripts\%SQLVARF%>>work_spc\scripts\messages.sql
java com.ibm.rational.vega.dw.SearchAndReplace CRREW4602E work_spc\scripts\%SQLVARF%>>work_spc\scripts\messages.sql
%CONNSTR%
db2 "SET CURRENT SCHEMA %STAR_SCHEMA%"
%DB2_CMD% work_spc\scripts\messages.sql>logs\messages.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\messages.log>nul
IF "%ERRORLEVEL%" EQU "1" (
SET MESSAGE=%CRREWMSGE104%  
SET EXITCODE=%CRREW4604E%
GOTO done)
db2 CONNECT RESET
)

FOR /F "usebackq delims==" %%g IN (`%CONNSTR% ^& db2 -x + -o - "SELECT COUNT(*) FROM SYSCAT.PROCEDURES WHERE PROCNAME IN ('DW_MIGRATE','MIGRATE_MODULE','PROCESS_UOW','VALIDATE_EXISTENCE')"`) do (set EXISTS=%%g)   

SET EXISTS=%EXISTS: =%
IF "%EXISTS: =%" NEQ "0" (
%CONNSTR%
db2 "drop procedure DW_MIGRATE"
db2 "drop procedure MIGRATE_MODULE"
db2 "drop procedure PROCESS_UOW"
db2 "drop procedure VALIDATE_EXISTENCE"
db2 "drop function REPLACE_SCHEMA"
)

FOR /F "usebackq delims==" %%g IN (`%CONNSTR% ^& db2 -x + -o - "SELECT COUNT(*) FROM SYSCAT.TABLES WHERE TABNAME IN ('MODULES','STATEMENT_LIST','STATEMENT_DEPENDENCIES')"`) do (set EXISTS=%%g)
SET EXISTS=%EXISTS: =%
IF "%EXISTS: =%" EQU "0" (
%CONNSTR%
%DB2_CMD% work_spc\ddl\createMIG.ddl> logs\createMIG.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\createMIG.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE016%  
SET EXITCODE=%CRREW4516E%
ECHO %CRREWECH006%
GOTO done)
)

%CONNSTR%
%DB2_CMD% work_spc\scripts\statements.sql> logs\statements.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\statements.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE020%  
SET EXITCODE=%CRREW4520E%
ECHO %CRREWECH010%
GOTO done)

%CONNSTR%
IF "%VIEW_REDEF%" EQU "1" (
db2 "UPDATE CONFIG.STATEMENT_LIST SET EXECUTE=1 WHERE RTRIM(ACTION)='ALTER VIEW'">nul )

%CONNSTR%
db2 -td@ -vf work_spc\scripts\migration_sp.sql> logs\migration_sp.log

%CONNSTR%

db2 "ALTER TABLE %NF_SCHEMA%.BUILD ALTER COLUMN BUILDING_TIME SET DATA TYPE  BIGINT"              
db2 "ALTER TABLE %NF_SCHEMA%.BUILD ALTER COLUMN WAITING_TIME SET DATA TYPE  BIGINT"               
db2 "REORG TABLE %NF_SCHEMA%.BUILD"                                  
db2 "ALTER TABLE %NF_SCHEMA%.PROJECT_BASELINE ALTER COLUMN EXTERNAL_KEY2 SET DATA TYPE  CHAR(80)" 
db2 "REORG TABLE %NF_SCHEMA%.PROJECT_BASELINE" 
                      
%CONNSTR%
DB2 SET CURRENT SCHEMA %DBUSER%
db2 "CALL %DBUSER%.DW_MIGRATE('%NF_SCHEMA%','%STAR_SCHEMA%','%REP_USER%')" >logs\migrateDB.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\migrateDB.log>nul
IF "%ERRORLEVEL%" EQU "1" (
SET MESSAGE=%CRREWMSGE103%  
SET EXITCODE=%CRREW4603E% 
GOTO done)

GOTO done

:done 
db2 connect reset 
db2 terminate
echo %MESSAGE%:%EXITCODE%
echo %CRREWECH002%
EXIT /B %EXITCODE%



